(module app-bad-tests mzscheme
  (require "test.scm")
  
  
  ;; we just avoid testing mzscheme for these
  (define (to-mz x) 1)
  
  (define app-bad-ts
    (test-suite
     "app-bad.scm"
     to-mz
     equal?
     (test "single negation"
           '(store () (- 1))
           '(store () -1))
     
     (test "double negation"
           '(store () (- (- 1)))
           '(store () 1))
     
     (test "begin"
           '(store ((x 1)) (begin (set! x (begin (set! x (- x)) (- x))) x))
           '(store ((x 1)) 1))
     
     (test/anss "many answers"
                '(store ((x 1))
                        ((lambda (p q) x)
                         (set! x (- x))
                         (set! x (- x))))
                (list '(store ((x 1)
                               (p1 unspecified)
                               (q1 unspecified))
                              1)
                      '(store ((x -1)
                               (p1 unspecified)
                               (q1 unspecified))
                              -1)))
     
     (test/anss "two answers"
                '(store ((x 1))
                        ((lambda (p q) 1)
                         (set! x 5)
                         (set! x 6)))
                (list '(store ((x 5)
                               (p1 unspecified)
                               (q1 unspecified))
                              1)
                      '(store ((x 6)
                               (p1 unspecified)
                               (q1 unspecified))
                              1)))))
  
  (provide app-bad-ts))
